#define F_CPU 12000000UL
#include<avr/io.h>
#include<util/delay.h>
#include<stdio.h>
void light(char side,char color,int delay){
	switch(side){
	case 'L':
		switch(color){
			case 'G': PORTC |= 0b010111;
				break;
			case 'R': PORTC |= 0b100111;
				break;
			case 'P': PORTC |= 0b001111;
				break;
			case 'Y': PORTB |= 0b000001;
				break;
			}
			break;
	case 'R':
		switch(color){
			case 'G': PORTB |= 0b010000;
				break;
			case 'P': PORTB |= 0b001000;
				break;
			case 'R': PORTB |= 0b000100;
				break;
			}
			break;
	}
	_delay_ms(delay*0.7);
	if(delay!=0){
	PORTC = 0b000111;
	PORTB = 0b000000;
	}
}
void pattern(int pattern)
{
	PORTB = 0b000000;
	PORTC &= 0b000111;
	if(pattern==0|pattern ==2)
	{
	light('L','R',75);
	light('L','P',75);
	light('L','G',75);
	}
	light('L','Y',75);
	if(pattern == 0|pattern == 1)
	{
	light('R','G',75);
	light('R','P',75);
	light('R','R',150);
	light('R','P',75);
	light('R','G',75);
	}
	light('L','Y',75);
	if(pattern == 0|pattern == 2)
	{
	light('L','G',75);
	light('L','P',75);
	light('L','R',75);
	}
	if(pattern == 0|pattern == 1)
	{
	light('R','R',75);
	light('R','P',75);
	light('R','G',75);
	}
	light('L','Y',75);
	if(pattern == 0|pattern == 2)
	{
	light('L','G',75);
	light('L','P',75);
	light('L','R',75);
	}
	if(pattern==0|pattern ==2)
	{
	light('L','R',75);
	light('L','P',75);
	light('L','G',75);
	}
	light('L','Y',75);
	if(pattern == 0|pattern == 1)
	{
	light('R','G',75);
	light('R','P',75);
	light('R','R',75);
	}
	PORTC |= 0b111111;
	PORTB |= 0b111111;
	_delay_ms(150);
	PORTC &= 0b000111;
	PORTB &= 0b000000;
	_delay_ms(150);
	PORTC |= 0b111111;
	PORTB |= 0b111111;
	_delay_ms(150);
	PORTC &= 0b000111;
	PORTB &= 0b000000;
	_delay_ms(150);
	PORTC |= 0b111111;
	PORTB |= 0b111111;
	_delay_ms(150);
	PORTC &= 0b000111;
	PORTB &= 0b000001;
	_delay_ms(150);
}
void showlight(int *boilcat)
{
	char side,color;
	int quit = 0;
	if(*boilcat>0)
		side = 'L';
	else
	{
		side = 'R';
		*boilcat *= -1;
	}
	if(*boilcat !=0)
	if(*boilcat<5)
		color = 'G';
	else if(*boilcat<10)
		color = 'P';
	else if(*boilcat<20)
		color = 'R';
	else
		{
			if(side =='R')
				pattern(1);
			else
				pattern(2);
			*boilcat = 0;
			quit = 1;
		}
	if(quit==0)
	{
		PORTB &= 0b000001;
		PORTC = 0b000111;
		light(side,color,0);
		if(side == 'R')
			*boilcat *= -1;
			}
}
main(){
	int boilcat = 0;
	int catleft = 0,catright = 0;
	DDRC = 0b111000;
	DDRB = 0b111111;
	PORTC |= 0b000111;
	PORTB |= 0b000001;
	while(1)
	{
			if(!(PINC & 0b000001))
				{
					boilcat = 0;
					pattern(0);
				}
			if(!(PINC & 0b000010))
				{
					catleft = 1;
				}
			else
				{
					if(catleft ==1)
					{
						boilcat++;
						catleft = 0;
					}
				}
			if(!(PINC & 0b000100))
				{
					catright = 1;
				}
			else
				{
					if(catright ==1)
					{
						boilcat--;
						catright = 0;
					}
				}
			showlight(&boilcat);
	}
}
